//
//  MINTLIncrementalSearchField.swift
//  migemodoki
//
//  Created by narita on 2017/10/31.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa

class MINTLIncrementalSearchField: NSSearchField
{
    // MARK: - class methods

    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    // IM入力中もnotificationを呼び出し続けるのをデフォルトの値とする
    override func awakeFromNib()
    {
        if let theTextFieldCell = self.cell as! NSTextFieldCell?
        {
            theTextFieldCell.setWantsNotificationForMarkedText(true)
        }
    }

    // self.window?
    //     open func fieldEditor(_ createFlag: Bool, for object: Any?) -> NSText?

    
    // MARK: - action methods

    // MARK: - event handling methods
    
    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    var isKanaKanjiTranslate: Bool
    {
        get
        {
            let theTranslateIds: Array = [
                "com.apple.inputmethod.Kotoeri.Japanese", // ひらがな
                "com.apple.inputmethod.Kotoeri.Japanese.Katakana", // カタカナ
                "com.apple.inputmethod.Kotoeri.Japanese.FullWidthRoman", // 全角英数字
                "com.apple.inputmethod.Kotoeri.Japanese.HalfWidthKana", // 半角カタカナ
            ]
            
            if let theString = NSTextInputContext.current?.selectedKeyboardInputSource?.rawValue
            {
                return theTranslateIds.contains(theString)
            }
            
            return false
        }
    }

    // MARK: - Utility methods

    // IMの支配下にあるmarkedRangeの文字列と、その前後の文字列をタプルで返す
    func incrementalStrings() -> (String, String, String)
    {
        let theTextInputContext = NSTextInputContext.current
        
        let theRange = theTextInputContext?.client.markedRange()

        let theString = self.stringValue as NSString
        
        return (
            theString.substring(to:theRange!.location),
            theString.substring(with:theRange!),
            theString.substring(from:theRange!.location + theRange!.length)
        )
    }

}
