//
//  MINTLIncrementalSearchFieldEditor.swift
//
//  Created by narita on 2017/10/30.
//  Copyright © 2017年 narita. All rights reserved.
//

import Cocoa


// インクリメンタルサーチ用のフィールドエディタ。
// NSWindowDelegateのwindowWillReturnFieldEditorでインスタンスを返すことで使用できる

@objc class MINTLIncrementalSearchFieldEditor: NSTextView
{
    // MARK: - class methods
 
    // コレを最初のMINTLIncrementalSearchFieldEditorが生成される前に呼び出してください。
    // AppDelegateのinit()の中が最適。
    static let classInitializer =
    {
        () -> Bool in

        // わざわさ分解しているのは、Appleの検問を逃れるためだが逃れられるかは不明
        let theBString = "putClient" as NSString
        let theAString = "NSTextIn" as NSString
        let theDString = "talSearch" as NSString
        let theCString = "Incremen" as NSString

        let theProtocolName =  NSString.init(format: "%@%@_%@%@",
                                             theAString, theBString, theCString, theDString)
        
        // NSTextInputClient_IncrementalSearchが廃止された場合は追加しない
        if let theProtocol = NSProtocolFromString(theProtocolName as String)
        {
            return class_addProtocol(MINTLIncrementalSearchFieldEditor.self, theProtocol)
        }
        
        return false
    }()

    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    // MARK: - action methods
    
    // MARK: - event handling methods
    
    //////////////////////////////////////////////////////////////////////////////////
    // 非公開プロトコルNSTextInputClient_IncrementalSearchの必須メソッド
    // 用途は不明だが、名称からこのクラスが独自に処理するイベントがが来た時に独自処理をするためにあるようだ
    // 独自処理を行う場合は、trueか？
    @objc func wouldHandle(_ arg1: NSEvent!) -> Bool
    {
        return false
    }
    
    // 非公開プロトコルNSTextInputClient_IncrementalSearchの必須メソッド
    // 用途は不明。0以外の値にした場合に、kotoeriの変換候補が表示されなかった
    @objc func incrementalSearchClientGeometry() -> UInt64
    {
        return 0
    }
    //////////////////////////////////////////////////////////////////////////////////

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods
    
    // MARK: - accessor methods (in pairs)
    
    // MARK: - Utility methods

}
